<?php

# $Id: esphtml.forms.php,v 1.1.1.1 2005/08/10 12:14:03 yoshis Exp $

// Written by James Flemer
// For eGrad2000.com
// <jflemer@alum.rpi.edu>

// string	mkwarn(char *warning);
// string	mkerror(char *error);

// string	mkradio(char *name, char *value);
// string	mkcheckbox(char *name, char *value);
// string	mktext(char *name);
// string	mktextarea(char *name, int rows, int cols, char *wordwrap);
// string	mkselect(char *name, char *options[]);
// string	mkfile(char *name);
class bmSurveyHtmlForms {
	var $htmlTag;
	function bmSurveyHtmlForms () {
		$this->htmlTag = array();
	}
	function getHtmlTag(){
		$ret = $this->htmlTag;
		$this->htmlTag = array();
		return $ret;
	}
	
	/* {{{ proto string mkerror(string message)
	   Returns HTML format for an error message. */
	function mkerror ($msg) {
		return("<font color=\"". $GLOBALS['ESPCONFIG']['error_color'] ."\" size=\"+1\">[ ${msg} ]</font>\n");
	}
	/* }}} */
	function mkother($_name,$value){
		$res = "<input type=\"text\" size=\"20\" name=\"$_name\" onKeyPress=\"other_check(this.name)\"";
		$res .= "value=\"". htmlspecialchars($value)."\"";
		$res .= ">";
		$this->htmlTag[] = array(
			'type'=>"text",
			'name'=>htmlspecialchars($_name),
			'value'=>htmlspecialchars($value),
			'onKeyPress'=>"other_check(this.name)",
		);	
		return $res;
	}
	function mkrankTitle($_name,$value){
		$this->htmlTag[] = array(
			'type'=>null,
			'name'=>htmlspecialchars($_name),
			'value'=>htmlspecialchars($value),
		);	
		return $value;
	}
	function mkattach($_name,$size,$maxfilesize){
		$res = "<INPUT TYPE='hidden' NAME='MAX_FILE_SIZE' VALUE='".$maxfilesize."'>".
			"<INPUT type='file' size='".$size."' name='".$_name."' /> Max ".maxbyte_str($maxfilesize)."Byte.";
		$this->htmlTag[] = array(
			'type'=>'file',
			'name'=>htmlspecialchars($_name),
			'size'=>$size,
			'max'=>$maxfilesize
		);	
		return $res;
	}
	/* {{{ proto string mkradio(string name, string value)
	   Returns HTML format for a radio button. */
	function mkradio ($_name, $value, $varr = null, $message=null ) {
	    if ($varr == null)
	        $varr =& $GLOBALS['_POST'];
		$str = '<input type="radio" name="' . htmlspecialchars($_name) .'" value="' . htmlspecialchars($value) .'"';
		$checked = false;
		if((isset($varr[$_name])) && (($varr[$_name] == $value) or ($varr[$_name][0] == $value ))) $checked = true;
		$str .= $checked ? " checked" : "";
		$str .= ' />';
		$this->htmlTag[] = array(
			'type'=>"radio",
			'name'=>htmlspecialchars($_name),
			'value'=>htmlspecialchars($value),
			'checked'=>$checked,
			'message'=>$message
		);	
		return($str);
	}
	function mkradioCancel ($_name, $value ) {
		$this->htmlTag[] = array(
			'type'=>"button",
			'name'=>"Button",
			'value'=>htmlspecialchars($value),
			'onclick'=>'uncheckRadio(\''.$_name.'\')'
		);	
		return '<input type="button" name="Button" value="' . $value . '" onclick="uncheckRadio(\''.$_name.'\')" />';
	}
	/* }}} */
		
	/* {{{ proto string mkcheckbox(string name, string value)
	   Returns HTML format for a check box. */
	function mkcheckbox ($_name, $value, $varr=null, $message=null) {
	    if ($varr == null) $varr =& $GLOBALS['_POST'];
		$checked = false;
		$str = '<input type="checkbox" name="' . htmlspecialchars($_name) .'[]" value="' . htmlspecialchars($value) .'"';
		if (isset($varr[$_name]) && is_array($varr[$_name]) && (in_array($value,$varr[$_name]) or in_array($value,$varr[$_name][0])) )
			 $checked = true;
		$str .= $checked ? " checked" : "";
		$str .= ' />';
		$this->htmlTag[] = array(
			'type'=>"checkbox",
			'name'=>htmlspecialchars($_name),
			'value'=>htmlspecialchars($value),
			'checked'=>$checked,
			'message'=>$message
		);	
		return($str);
	}
	/* }}} */
	
	/* {{{ proto string mktext(string name, int size)
	   Returns HTML format for a text entry line. */
	function mktext ($_name, $size = 20, $max = 0, $varr = null) {
		if ($varr == null) $varr =& $GLOBALS['_POST'];
		$size = intval($size);
		$max  = intval($max);
		$str = "size=\"$size\"";
		if ($max)	$str .= " maxlength=\"$max\"";
		if (isset($varr[$_name])) $value = htmlspecialchars($varr[$_name]);
		else $value=null;
		$this->htmlTag[] = array(
			'type'=>"text",
			'name'=>htmlspecialchars($_name),
			'value'=>htmlspecialchars($value)
		);
		$rstr = '<input type="text" '. $str .' name="'. htmlspecialchars($_name) .'"';
		$rstr .= $value ? ' value="' . $value .'"' : '';
		$rstr .= ' />';
		return $rstr;
	}
	/* }}} */
	
	/* {{{ proto string mkpass(string name)
	   Returns HTML format for a password entry line. */
	function mkpass ($_name) {
		return('<input type="password" name="'. htmlspecialchars($_name) .'" />');
	}
	/* }}} */
	
	/* {{{ proto string mkhidden(string name)
	   Returns HTML format for a hidden form field. */
	function mkhidden ($_name, $varr = null) {
	    if ($varr == null)
	        $varr =& $GLOBALS['_POST'];
		if (isset($varr[$_name]))
			return('<input type="hidden" name="'. htmlspecialchars($_name) .'" value="'. htmlspecialchars($varr[$_name]) .'" />');
		return('<input type="hidden" name="'. htmlspecialchars($_name) .'" />');
	}
	/* }}} */
	
	/* {{{ proto string mktextarea(string name, int rows, int cols, string wrap_type)
	   Returns HTML format for a text entry box. */
	function mktextarea ($_name, $rows, $cols, $wrap, $varr = null) {
	    if ($varr == null)
	        $varr =& $GLOBALS['_POST'];
		$str = '<textarea name="' . htmlspecialchars($_name) .'"';
		if($rows > 0)
			$str .= ' rows="' . $rows . '"';
		if($cols > 0)
			$str .= ' cols="' . $cols . '"';
		if($wrap != '')
			$str .= ' wrap="' . strtolower($wrap) . '"';
		$str .= '>';
		$value = null;
		if (isset($varr[$_name])){
			$value = htmlspecialchars($varr[$_name]);
			$str .= $value;
		}
		$str .= '</textarea>';
		$this->htmlTag[] = array(
			'type'=>"textarea",
			'name'=>htmlspecialchars($_name),
			'rows'=>$rows,
			'cols'=>$cols,
			'value'=>$value,
			'wrap'=>$wrap
		);	
		return($str);
	}
	/* }}} */
	
	/* {{{ proto string mkselect(string name, array options)
	   Returns HTML format for a select box (dropdown). */
	function mkselect ($_name, $options, $varr = null) {
	    if ($varr == null) $varr =& $GLOBALS['_POST'];
		$str  = "<select name=\"${_name}\">\n";
		$str .= "<option></option>\n";
		$opt=array();
		while(list($cid, $content) = each($options)) {
			$checked = '';
			if (isset($varr[$_name])){
				if ( is_array($varr[$_name]) )
					$nm = $varr[$_name][0];
				else
					$nm = $varr[$_name];
				if ($nm == $cid) $checked = ' selected';
			}
			$str .= "<option value=\"${cid}\"${checked}>${content}</option>\n";
			$opt[]=array(
				'value'=>$cid,
				'checked'=>$checked,
				'content'=>$content
			);
		}
		$str .= "</select>\n";
		$this->htmlTag[] = array(
			'type'=>"select",
			'name'=>htmlspecialchars($_name),
			'value'=> $opt
		);			
		return($str);
	}
	/* }}} */
	
	/* {{{ proto string mkfile(string name)
	   Returns HTML format for a file selection button. */
	function mkfile ($_name) {
		return('<input type="file" name="'.htmlspecialchars($_name) .'" />');
	}
	/* }}} */
	
	/* {{{ proto string mksubmit(string name, string value)
	   Returns HTML format for a submit button. */
	function mksubmit($_name, $_value = null) {
	    if ($_value == null)
	        $_value = _GT_Submit;
	    if (!empty($_value))
	        $_value = ' value="'.htmlspecialchars($_value).'"';
	    return '<input type="submit" name="'.htmlspecialchars($_name).'"'.$_value.' />';
	}
	/* }}} */
}
?>