<?php
// $Id: index.php,v 0.82 2007/12/04 12:40:03 yoshis Exp $
//  ------------------------------------------------------------------------ //
//                      BmSurvey - Bluemoon Multi-Survey                     //
//                   Copyright (c) 2005 - 2007 Bluemoon inc.                 //
//                       <http://www.bluemooninc.biz/>                       //
//              Original source by : phpESP V1.6.1 James Flemer              //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
require('../../mainfile.php');
require(XOOPS_ROOT_PATH.'/header.php');
include_once('admin/phpESP.ini.php');
include_once('./class/bmsurveyUtils.php');

$sid = $manage_on = 0;
if(isset($_POST['sid'])) $sid = intval($_POST['sid']);
elseif(isset($_GET['sid'])) $sid = intval($_GET['sid']);


// display control
$manage_on = isset($_SESSION['survey_index']['manage_on']) ? $_SESSION['survey_index']['manage_on'] : -1;
$sortby    = isset($_SESSION['survey_index']['sortby'   ]) ? $_SESSION['survey_index']['sortby'   ] : NULL;
$order     = isset($_SESSION['survey_index']['order'    ]) ? $_SESSION['survey_index']['order'    ] : 'DESC';
// get from usesr
$manage_on = isset($_GET['manage_on']) ? intval($_GET['manage_on']) : $manage_on;
$sortby = isset($_GET['sortby']) ? htmlspecialchars ( rawurldecode($_GET['sortby']) , ENT_QUOTES ) : 'changed';
$order = isset($_GET['order']) ? htmlspecialchars ( rawurldecode($_GET['order']) , ENT_QUOTES ) : 'desc';
$altorder = ($order=='asc') ? 'desc' : 'asc';
// stock to session
$_SESSION['survey_index']['manage_on'] = $manage_on;
$_SESSION['survey_index']['sortby'] = $sortby;
$_SESSION['survey_index']['$order'] = $order;

// Check if the user as admin right to the module
$surveyManager = false;
$is_mod_admin = false;
if (is_object($xoopsUser) ){
	if ( isset($xoopsModuleConfig['MANAGERS']) ){
	    //if (is_object($xoopsMSModule) && $xoopsMSModule->getVar('isactive')){
	        $groups = $xoopsUser->getGroups();
    	    if (array_intersect($xoopsModuleConfig['MANAGERS'], $groups)){
				$surveyManager = true;
    	    }
    	//}
    }
    // Check if the user as admin right to the module
	if ( $xoopsUser->isAdmin($xoopsModule->mid()) ) {
	    $is_mod_admin = true;
	}
}
$tpl_vars = array(
	'content' => array(),
	'langs' => array(
		'pagetitle' => BMSURVEY_INDEX_PAGETITLE,
		'survey_title' => BMSURVEY_LIST_TITLE,
		'survey_subtitle' => BMSURVEY_LIST_SUBTITLE,
		'survey_name' => BMSURVEY_LIST_NAME,
		'survey_owner' => BMSURVEY_LIST_OWNER,
		'survey_updatedat' => BMSURVEY_LIST_UPDATEDAT,
		'survey_submitted' => BMSURVEY_LIST_SUBMITTED,
		'col_data' => BMSURVEY_LIST_COL_DATA,
		'col_results' => BMSURVEY_LIST_COL_RESULTS,
		'col_results_analyze' => BMSURVEY_LIST_COL_RESULTS_ANALYZE,
		'col_results_respondents' => BMSURVEY_LIST_COL_RESULTS_RESPONDENTS,
		'col_results_spreadsheet' => BMSURVEY_LIST_COL_RESULTS_SPREADSHEET,
		'col_results_cross' => BMSURVEY_LIST_COL_RESULTS_CROSS,
		'col_results_download' => BMSURVEY_LIST_COL_RESULTS_DOWNLOAD,
		'col_control' => BMSURVEY_LIST_COL_CONTROL,
		'col_control_modify' => BMSURVEY_LIST_COL_CONTROL_MODIFY,
		'col_control_status' => BMSURVEY_LIST_COL_CONTROL_STATUS,
		'col_control_access' => BMSURVEY_LIST_COL_CONTROL_ACCESS,
		'col_control_access_public' => BMSURVEY_LIST_COL_CONTROL_ACCESS_PUBLIC,
		'col_control_access_limited' => BMSURVEY_LIST_COL_CONTROL_ACCESS_LIMITED,
		'col_control_access_2public' => BMSURVEY_LIST_COL_CONTROL_ACCESS_2PUBLIC,
		'col_control_access_2limited' => BMSURVEY_LIST_COL_CONTROL_ACCESS_2LIMITED,
		'col_control_access_setperm' => BMSURVEY_LIST_COL_CONTROL_ACCESS_SETPERM,
		'col_control_access' => BMSURVEY_LIST_COL_CONTROL_ACCESS,
		'col_control_copy' => BMSURVEY_LIST_COL_CONTROL_COPY,
		'col_control_edit' => BMSURVEY_LIST_COL_CONTROL_EDIT
	),
	'config' => array(
		'listview' => 'simple',
		'surveyManager'=>$surveyManager,
		'is_mod_admin'=>$is_mod_admin
	)
);
$langs = get_defined_constants();

$bmutil = new bmsurveyUtils($sid);
if (!$sid){
	if($xoopsUser && $manage_on){
		$tpl_vars['content']['surveys'] = $bmutil->get_survey_list(0, FALSE, $sortby, $order, FALSE, $xoopsUser->uid());
	}else{
		$tpl_vars['content']['surveys'] = $bmutil->get_survey_list(0, FALSE, $sortby, $order);
	}
	$xoopsOption['template_main'] = 'bmsurvey_index.html';
}else{
	$tpl_vars['content']['survey'] = $bmutil->surveyInfo;
	$xoopsOption['template_main'] = 'bmsurvey_controlpanel.html';
}

$xoopsTpl->assign('xoops_module_header', '<link rel="stylesheet" type="text/css" media="screen,tv,print" href="style.css" />');
$xoopsTpl->assign('manage_on', $manage_on);
$xoopsTpl->assign('order', $altorder);
$xoopsTpl->assign('bmsurvey', $tpl_vars);
include(XOOPS_ROOT_PATH.'/footer.php');
?>
